﻿// BadRandomRectangles (c) 2009 by Charles Petzold
using System;
using System.Windows;
using System.Windows.Controls;
using System.Windows.Media;
using System.Windows.Shapes;

namespace BadRandomRectangles
{
    public partial class MainPage : UserControl
    {
        Random rand = new Random();
        ulong count = 0;

        public MainPage()
        {
            InitializeComponent();
            CompositionTarget.Rendering += OnRendering;
        }

        void OnRendering(object sender, EventArgs args)
        {
            int width = (int)LayoutRoot.ActualWidth;
            int height = (int)LayoutRoot.ActualHeight;

            if (width == 0 || height == 0)
                return;

            int x1 = rand.Next(width);
            int x2 = rand.Next(width);
            int y1 = rand.Next(height);
            int y2 = rand.Next(height);

            byte[] bytes = new byte[4];
            rand.NextBytes(bytes);
            Color clr = Color.FromArgb(bytes[0], bytes[1], 
                                       bytes[2], bytes[3]);
            Path path = new Path()
            {
                Fill = new SolidColorBrush(clr),
                Data = new RectangleGeometry()
                {
                    Rect = new Rect(Math.Min(x1, x2), 
                                    Math.Min(y1, y2),
                                    Math.Abs(x1 - x2), 
                                    Math.Abs(y1 - y2))
                }
            };

            LayoutRoot.Children.Add(path);
            txt.Text = (++count).ToString();
        }
    }
}
